/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Utils.vala
 *
 * Copyright 2019 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "pqmarble.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

GtkCssProvider*
pq_marble_get_css_provider_for_data (const gchar* data)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* result;
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	gtk_css_provider_load_from_string (provider, data);
	result = provider;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
pq_marble_set_theming_for_data (GtkWidget* widget,
                                const gchar* data,
                                const gchar* class_name,
                                gint priority)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkCssProvider* _tmp3_;
	g_return_if_fail (widget != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = pq_marble_get_css_provider_for_data (data);
	provider = _tmp0_;
	_tmp1_ = gtk_widget_get_style_context (widget);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	ctx = _tmp2_;
	_tmp3_ = provider;
	if (_tmp3_ != NULL) {
		GtkStyleContext* _tmp4_;
		GtkCssProvider* _tmp5_;
		_tmp4_ = ctx;
		_tmp5_ = provider;
		gtk_style_context_add_provider (_tmp4_, (GtkStyleProvider*) _tmp5_, (guint) priority);
	}
	if (class_name != NULL) {
		GtkStyleContext* _tmp6_;
		_tmp6_ = ctx;
		gtk_style_context_add_class (_tmp6_, class_name);
	}
	_g_object_unref0 (ctx);
	_g_object_unref0 (provider);
}

void
pq_marble_add_css_provider_from_resource (const gchar* resource,
                                          gint priority,
                                          GdkDisplay* display)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	g_return_if_fail (resource != NULL);
	g_return_if_fail (display != NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	gtk_css_provider_load_from_resource (provider, resource);
	gtk_style_context_add_provider_for_display (display, (GtkStyleProvider*) provider, (guint) priority);
	_g_object_unref0 (provider);
}

